
/******************************************************************************
* MODULE     : keyw_forallval.cc
* DESCRIPTION: Template values
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
namespace mmx {

void
evaluator_rep::kw_forallval_1 () {
  evaluate_arg (car (trace) [2], KW_FORALLVAL_2);
}

void
evaluator_rep::kw_forallval_2 () {
  // INPUT: (forallval_2, type, cont, ...)
  list    qval= as_list (car (trace));
  generic val = list (car (qval), env, cadr (qval), cadddr (qval));
  generic type= V (car (rem));
  cur= cadr (rem);
  rem= cons (value (val, type), cddr (rem));
  // OUTPUT: (cont, val, ...)
  trace= cdr (trace);
}

} // namespace mmx
